# LDAP Account Manager

# lib/3rdParty/phpseclib/Crypt/Rijndael.php

# Properties

author
category
copyright
license
link
package
version

## Description

Pure-PHP implementation of Rijndael.
Does not use mcrypt, even when available, for reasons that are explained below. PHP versions 4 and 5 If {@link Crypt_Rijndael::setBlockLength() setBlockLength()} isn't called, it'll be assumed to be 128 bits. If {@link Crypt_Rijndael::setKeyLength() setKeyLength()} isn't called, it'll be calculated from {@link Crypt_Rijndael::setKey() setKey()}. ie. if the key is 128-bits, the key length will be 128-bits. If it's 136-bits it'll be null-padded to 160-bits and 160 bits will be the key length until {@link Crypt_Rijndael::setKey() setKey()} is called, again, at which point, it'll be recalculated. Not all Rijndael implementations may support 160-bits or 224-bits as the block length / key length. mcrypt, for example, does not. AES, itself, only supports block lengths of 128 and key lengths of 128, 192, and 256. {@link http://csrc.nist.gov/archive/aes/rijndael/Rijndael-ammended.pdf#page=10 Rijndael-ammended.pdf#page=10} defines the algorithm for block lengths of 192 and 256 but not for block lengths / key lengths of 160 and 224. Indeed, 160 and 224 are first defined as valid key / block lengths in {@link http://csrc.nist.gov/archive/aes/rijndael/Rijndael-ammended.pdf#page=44 Rijndael-ammended.pdf#page=44}: Extensions: Other block and Cipher Key lengths. {@internal The variable names are the same as those in {@link http://www.csrc.nist.gov/publications/fips/fips197/fips-197.pdf#page=10 fips-197.pdf#page=10}.}} Here's a short example of how to use this library: `setKey('abcdefghijklmnop'); $size = 10 * 1024; $plaintext = ''; for ($i = 0; $i < $size; $i++) { $plaintext.= 'a'; } echo $rijndael->decrypt($rijndael->encrypt($plaintext)); ?>` LICENSE: Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## Constants

### CRYPT_RIJNDAEL_MODE_CTR = -1

Encrypt / decrypt using the Counter mode.
Set to -1 since that's what Crypt/Random.php uses to index the CTR mode.

### CRYPT_RIJNDAEL_MODE_ECB = 1

Encrypt / decrypt using the Electronic Code Book mode.

### CRYPT_RIJNDAEL_MODE_CBC = 2

Encrypt / decrypt using the Code Book Chaining mode.

### CRYPT_RIJNDAEL_MODE_CFB = 3

Encrypt / decrypt using the Cipher Feedback mode.

### CRYPT_RIJNDAEL_MODE_OFB = 4

Encrypt / decrypt using the Cipher Feedback mode.

### CRYPT_RIJNDAEL_MODE_INTERNAL = 1

Toggles the internal implementation

### CRYPT_RIJNDAEL_MODE_MCRYPT = 2

Toggles the mcrypt implementation

## Classes

### Crypt_Rijndael

# Properties

Extends
Implements
access
public
author
Jim Wigginton
package
Crypt_Rijndael
version
0.1.0
Abstract
No
Final
No

#### Description

Pure-PHP implementation of Rijndael.

#### Methods

Crypt_Rijndael, _decryptBlock, _encryptBlock, _generate_xor, _invSubWord, _pad, _setup, _string_shift, _subWord, _unpad, decrypt, disableContinuousBuffer, disablePadding, enableContinuousBuffer, enablePadding, encrypt, setBlockLength, setIV, setKey, setKeyLength,

### Crypt_Rijndael( $mode = CRYPT_RIJNDAEL_MODE_CBC, ) : \Crypt_Rijndael

#### Description

Default Constructor.
Determines whether or not the mcrypt extension should be used. $mode should only, at present, be CRYPT_RIJNDAEL_MODE_ECB or CRYPT_RIJNDAEL_MODE_CBC. If not explictly set, CRYPT_RIJNDAEL_MODE_CBC will be used.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$mode | n/a |  | CRYPT_RIJNDAEL_MODE_CBC

#### Return value

Type | Description
--- | ---
\Crypt_Rijndael |

#### Tags

Name | Description
--- | ---
access | public

### _decryptBlock( String $in, ) : String

#### Description

Decrypts a block

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$in | String |  |

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | private

### _encryptBlock( String $in, ) : String

#### Description

Encrypts a block

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$in | String |  |

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | private

### _generate_xor( Integer $length, String $iv, ) : n/a

#### Description

Generate CTR XOR encryption key
Encrypt the output of this and XOR it against the ciphertext / plaintext to get the plaintext / ciphertext in CTR mode.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$length | Integer |  |
$iv | String |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
see |
access | public

### _invSubWord( $word, ) : n/a

#### Description

Performs inverse S-Box substitutions

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$word | n/a |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | private

### _pad( $text, ) : n/a

#### Description

Pads a string
Pads a string using the RSA PKCS padding standards so that its length is a multiple of the blocksize. $block_size - (strlen($text) % $block_size) bytes are added, each of which is equal to chr($block_size - (strlen($text) % $block_size) If padding is disabled and $text is not a multiple of the blocksize, the string will be padded regardless and padding will, hence forth, be enabled.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$text | n/a |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | private

### _setup( ) : n/a

#### Description

Setup Rijndael
Validates all the variables and calculates $Nr - the number of rounds that need to be performed - and $w - the key key schedule.

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | private

### _string_shift( String $string, $index = 1, ) : String

#### Description

String Shift
Inspired by array_shift

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$string | String |  |
$index | n/a |  | 1

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | private

### _subWord( $word, ) : n/a

#### Description

Performs S-Box substitutions

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$word | n/a |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | private

### _unpad( $text, ) : n/a

#### Description

Unpads a string.
If padding is enabled and the reported padding length is invalid the encryption key will be assumed to be wrong and false will be returned.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$text | n/a |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | private

### decrypt( String $ciphertext, ) : n/a

#### Description

Decrypts a message.
If strlen($ciphertext) is not a multiple of the block size, null bytes will be added to the end of the string until it is.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$ciphertext | String |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | public

### disableContinuousBuffer( ) : n/a

#### Description

Treat consecutive packets as if they are a discontinuous buffer.
The default behavior.

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | public

### disablePadding( ) : n/a

#### Description

Do not pad packets.

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | public

### enableContinuousBuffer( ) : n/a

#### Description

Treat consecutive "packets" as if they are a continuous buffer.
Say you have a 32-byte plaintext $plaintext. Using the default behavior, the two following code snippets will yield different outputs: `echo $rijndael->encrypt(substr($plaintext, 0, 16)); echo $rijndael->encrypt(substr($plaintext, 16, 16));` `echo $rijndael->encrypt($plaintext);` The solution is to enable the continuous buffer. Although this will resolve the above discrepancy, it creates another, as demonstrated with the following: `$rijndael->encrypt(substr($plaintext, 0, 16)); echo $rijndael->decrypt($des->encrypt(substr($plaintext, 16, 16)));` `echo $rijndael->decrypt($des->encrypt(substr($plaintext, 16, 16)));` With the continuous buffer disabled, these would yield the same output. With it enabled, they yield different outputs. The reason is due to the fact that the initialization vector's change after every encryption / decryption round when the continuous buffer is enabled. When it's disabled, they remain constant. Put another way, when the continuous buffer is enabled, the state of the Crypt_Rijndael() object changes after each encryption / decryption round, whereas otherwise, it'd remain constant. For this reason, it's recommended that continuous buffers not be used. They do offer better security and are, in fact, sometimes required (SSH uses them), however, they are also less intuitive and more likely to cause you problems.

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | public

### enablePadding( ) : n/a

#### Description

Pad "packets".
Rijndael works by encrypting between sixteen and thirty-two bytes at a time, provided that number is also a multiple of four. If you ever need to encrypt or decrypt something that isn't of the proper length, it becomes necessary to pad the input so that it is of the proper length. Padding is enabled by default. Sometimes, however, it is undesirable to pad strings. Such is the case in SSH, where "packets" are padded with random bytes before being encrypted. Unpad these packets and you risk stripping away characters that shouldn't be stripped away. (SSH knows how many bytes are added because the length is transmitted separately)

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | public

### encrypt( String $plaintext, ) : n/a

#### Description

Encrypts a message.
$plaintext will be padded with additional bytes such that it's length is a multiple of the block size. Other Rjindael implementations may or may not pad in the same manner. Other common approaches to padding and the reasons why it's necessary are discussed in the following URL: {@link http://www.di-mgt.com.au/cryptopad.html http://www.di-mgt.com.au/cryptopad.html} An alternative to padding is to, separately, send the length of the file. This is what SSH, in fact, does. strlen($plaintext) will still need to be a multiple of 8, however, arbitrary values can be added to make it that length.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$plaintext | String |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
see |
access | public

### setBlockLength( Integer $length, ) : n/a

#### Description

Sets the block length
Valid block lengths are 128, 160, 192, 224, and 256. If the length is less than 128, it will be rounded up to 128. If the length is greater then 128 and invalid, it will be rounded down to the closest valid amount.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$length | Integer |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | public

### setIV( String $iv, ) : n/a

#### Description

Sets the initialization vector. (optional)
SetIV is not required when CRYPT_RIJNDAEL_MODE_ECB is being used. If not explictly set, it'll be assumed to be all zero's.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$iv | String |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | public

### setKey( String $key, ) : n/a

#### Description

Sets the key.
Keys can be of any length. Rijndael, itself, requires the use of a key that's between 128-bits and 256-bits long and whose length is a multiple of 32. If the key is less than 256-bits and the key length isn't set, we round the length up to the closest valid key length, padding $key with null bytes. If the key is more than 256-bits, we trim the excess bits. If the key is not explicitly set, it'll be assumed to be all null bytes.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$key | String |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | public

### setKeyLength( Integer $length, ) : n/a

#### Description

Sets the key length
Valid key lengths are 128, 160, 192, 224, and 256. If the length is less than 128, it will be rounded up to 128. If the length is greater then 128 and invalid, it will be rounded down to the closest valid amount.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$length | Integer |  |

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | public

#### Properties

$c, $changed, $continuousBuffer, $debuffer, $decryptIV, $dt0, $dt1, $dt2, $dt3, $dw, $enbuffer, $encryptIV, $explicit_key_length, $iv, $key, $mode, $paddable, $padding, $t0, $t1, $t2, $t3, $w,

### Array public $c =

Shift offsets

### Boolean public $changed = true

Does the key schedule need to be (re)calculated?

### Boolean public $continuousBuffer = false

Continuous Buffer status

### String public $debuffer = array('ciphertext' => '')

Decryption buffer for CTR, OFB and CFB modes

### String public $decryptIV = ''

A "sliding" Initialization Vector

### Array public $dt0 =

Precomputed invMixColumns table

### Array public $dt1 =

Precomputed invMixColumns table

### Array public $dt2 =

Precomputed invMixColumns table

### Array public $dt3 =

Precomputed invMixColumns table

### Array public $dw =

The Inverse Key Schedule

### String public $enbuffer = array('encrypted' => '', 'xor' => '')

Encryption buffer for CTR, OFB and CFB modes

### String public $encryptIV = ''

A "sliding" Initialization Vector

### Boolean public $explicit_key_length = false

Has the key length explicitly been set or should it be derived from the key, itself?

### String public $iv = ''

The Initialization Vector

### String public $key = "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"

The Key

### Integer public $mode =

The Encryption Mode

### Boolean public $paddable = false

Is the mode one that is paddable?

### Boolean public $padding = true

Padding status

### Array public $t0 =

Precomputed mixColumns table

### Array public $t1 =

Precomputed mixColumns table

### Array public $t2 =

Precomputed mixColumns table

### Array public $t3 =

Precomputed mixColumns table

### Array public $w =

The Key Schedule
Documentation was generated by phpDocumentor 2.1.0 .

# Namespaces

- global

# Packages

- Crypt_AES
  - Crypt_AES
    Pure-PHP implementation of AES.
- Crypt_DES
  - Crypt_DES
    Pure-PHP implementation of DES.
- Crypt_Hash
  - Crypt_Hash
    Pure-PHP implementations of keyed-hash message authentication codes (HMACs) and various cryptographic hashing functions.
- Crypt_RC4
  - Crypt_RC4
    Pure-PHP implementation of RC4.
- Crypt_RSA
  - Crypt_RSA
    Pure-PHP PKCS#1 compliant implementation of RSA.
- Crypt_Random
- Crypt_Rijndael
  - Crypt_Rijndael
    Pure-PHP implementation of Rijndael.
- Crypt_TerraDES
  - Crypt_TripleDES
    Pure-PHP implementation of Triple DES.
- Crypt_TripleDES
- Help
- LDAP
  - Ldap
    Ldap manages connection to LDAP and includes several helper functions.
- Math_BigInteger
  - Math_BigInteger
    Pure-PHP arbitrary precision integer arithmetic library. Supports base-2, base-10, base-16, and base-256 numbers.
- Net_SFTP
  - Net_SFTP
    Pure-PHP implementations of SFTP.
- Net_SSH1
  - Net_SSH1
    Pure-PHP implementation of SSHv1.
- Net_SSH2
  - Net_SSH2
    Pure-PHP implementation of SSHv2.
- PDF
  - UFPDF
    Main UFPDF class for creating Unicode PDF documents
  - lamPDF
    Creates a LAM information page in PDF format.
  - xmlParser
    Simple XML parser.
- PHP_Compat
- configuration
  - LAMCfgMain
    This class manages config.cfg.
  - LAMConfig
    This class manages .conf files.
- horde.cipher
  - Horde_Cipher_blowfish
- lam
  - smbHash
    Calculates NT and LM hashes.
- lib
  - AttributeType
    Represents an LDAP AttributeType
  - MatchingRule
    Represents an LDAP MatchingRule
  - MatchingRuleUse
    Represents an LDAP schema matchingRuleUse entry
  - ObjectClass
    Represents an LDAP objectClass
  - ObjectClassAttribute
    A simple class for representing AttributeTypes used only by the ObjectClass class.
  - SchemaItem
    Generic parent class for all schema items. A schema item is an ObjectClass, an AttributeBype, a MatchingRule, or a Syntax.
  - Syntax
    Represents an LDAP Syntax
- lists
  - kolabSharedFolderTypeList
    Generates the list view.
  - lamAsteriskExtList
    Generates the list view.
  - lamBooleanListOption
    Boolean option for list configuration.
  - lamDHCPList
    Generates the list view.
  - lamGroupList
    Generates the list view.
  - lamHostList
    Generates the list view.
  - lamList
    Generates the list view.
  - lamListOption
    Represents a list configuration option.
  - lamListTool
    Represents a tool which can be included in the account lists.
  - lamMailAliasList
    Generates the list view.
  - lamNetgroupList
    Generates the list view.
  - lamPykotaBillingCodeTypeList
    Generates the list view.
  - lamPykotaPrinterTypeList
    Generates the list view.
  - lamSelectListOption
    Boolean option for list configuration.
  - lamSmbDomainList
    Generates the list view.
  - lamUserList
    Generates the list view.
- main
- metaHTML
  - htmlAccountPageButton
    Prints a button for the account pages.
  - htmlButton
    Simple button.
  - htmlDiv
    Creates a simple DIV element.
  - htmlElement
    Represents a HTML element.
  - htmlEqualHeight
    Sets all given elements to the same height.
  - htmlEqualWidth
    Sets all given elements to the same width.
  - htmlFieldset
    Generates a fieldset.
  - htmlGroup
    Groups multiple htmlElements.
  - htmlHelpLink
    Renders a help link.
  - htmlHiddenInput
    Generates a hidden input field.
  - htmlHorizontalLine
    Prints a horizontal line.
  - htmlImage
    Prints the HTML code for an image.
  - htmlInputCheckbox
    Prints the HTML code for a checkbox.
  - htmlInputField
    A standard input field.
  - htmlInputFileUpload
    Prints the HTML code for a file upload field.
  - htmlInputTextarea
    Prints the HTML code for a textarea.
  - htmlJavaScript
    Creates a JavaScript element.
  - htmlLink
    Generates a link.
  - htmlOutputText
    Prints the text and escapes contained HTML code by default.
  - htmlRadio
    Represents a radio selection.
  - htmlSelect
    Represents a select box.
  - htmlSortableList
    Creates a list of elements that can be sorted by the user via drag'n'drop.
  - htmlSpacer
    Adds an empty space with given width and height.
  - htmlStatusMessage
    Prints a status message (e.g. error message).
  - htmlSubTitle
    Generates a subtitle line. This is used to group multiple fields.
  - htmlTable
    Structures elements using a table.
  - htmlTableExtendedInputCheckbox
    Checkbox with descriptive label and help link.
  - htmlTableExtendedInputField
    An extended input field that combines label, input field and help.
  - htmlTableExtendedInputFileUpload
    File upload with descriptive label and help link.
  - htmlTableExtendedInputTextarea
    Text area with label and help link.
  - htmlTableExtendedRadio
    Radio list with descriptive label and help link.
  - htmlTableExtendedSelect
    Select with label and help link.
  - htmlTableRow
    A row inside a htmlTable.
  - htmlTitle
    Generates a title line. This is used for page titles.
- modules
  - account
    Manages the object class "account" for users and hosts.
  - accountContainer
    This class includes all modules and attributes of an account.
  - asteriskAccount
    Manages the Asterisk extension of user accounts.
  - asteriskExtension
    Manages Asterisk extensions.
  - asteriskVoicemail
    Manages the Asterisk extension of user accounts.
  - authorizedServiceObject
    Provides Authorized Service for accounts.
  - baseModule
    Parent class of all account modules.
  - ddns
    Manages DDNS entries.
  - dhcp_settings
    Manages DHCP entries.
  - eduPerson
    Manages the eduPerson extension for user accounts.
  - fixed_ip
    Manages DHCP host entries.
  - freeRadius
    Manages FreeRadius accounts.
  - generalInformation
    Shows general information like the creation time of an account.
  - hostObject
    Manages the hosts to which a user may login.
  - ieee802device
    Provides MAC addresses for hosts.
  - imapAccess
    Manages mailboxes on an IMAP server.
  - inetLocalMailRecipient
    Provides mail routing for users.
  - inetOrgPerson
    This module manages LDAP attributes of the object class inetOrgPerson (e.g. name and address).
  - kolabGroup
    Manages Kolab group accounts.
  - kolabSharedFolder
    Manages Kolab shared folders.
  - kolabUser
    Manages Kolab user accounts.
  - ldapPublicKey
    Manages SSH public keys.
  - nisMailAlias
    Provides NIS mail alias management.
  - nisnetgroup
    Manages entries based on the object class nisNetgroup.
  - passwordService
    This interface needs to be implemented by all account modules which manage passwords.
  - posixAccount
    Manages the object class "posixAccount" for users and hosts.
  - posixGroup
    Manages the object class "posixGroup" for groups.
  - puppetClient
    Manages Puppet configuration options.
  - pykotaBillingCode
    Manages PyKota billing codes.
  - pykotaGroup
    Manages PyKota group accounts.
  - pykotaGroupStructural
    Manages PyKota group accounts.
  - pykotaPrinter
    Manages PyKota printers.
  - pykotaUser
    Manages PyKota user accounts.
  - pykotaUserStructural
    Manages PyKota user accounts.
  - quota
    Manages quotas for users and groups.
  - range
    Manages DHCP ranges for DHCP server.
  - samba3domain
    Represents a Samba 3 domain entry
  - sambaDomain
    Manages Samba 3 domain entries.
  - sambaGroupMapping
    Manages the object class "sambaGroupMapping" for groups.
  - sambaMungedDial
    Manages terminal server settings for Samba 3.
  - sambaSamAccount
    Manages the object class "sambaSamAccount" for users and hosts.
  - shadowAccount
    Manages the object class "shadowAccount" for users.
  - smbHash
    Calculates NT and LM hashes.
  - systemQuotas
    Manages user quotas with the object class systemQuotas.
  - windowsGroup
    Manages Windows AD (e.g. Samba 4) groups.
  - windowsHost
    Manages Windows AD (e.g. Samba 4) hosts.
  - windowsPosixGroup
    Manages Unix groups in Windows LDAP schema.
  - windowsUser
    Manages Windows AD (e.g. Samba 4) users.
- phpLDAPadmin
- profiles
- selfService
  - selfServiceProfile
    Includes all settings of a self service profile.
- tools
  - LAMSubTool
    Represents a subtool.
  - LAMTool
    Represents a tool.
  - toolFileUpload
    File upload
  - toolMultiEdit
    Multi edit tool that allows LDAP operations on multiple entries.
  - toolOUEditor
    OU editor
  - toolPDFEditor
    PDF editor
  - toolProfileEditor
    Profile editor
  - toolSchemaBrowser
    Schema browser
  - toolServerInformation
    Server information
  - toolTests
    Tests page
- types
  - asteriskExt
    The account type for Asterisk extensions.
  - baseType
    This is the parent class of all account types.
  - dhcp
    The account type for DHCP
  - group
    The account type for group accounts (e.g. Unix and Samba).
  - host
    The account type for host accounts (e.g. Samba).
  - kolabSharedFolderType
    The account type for Kolab shared folders.
  - mailAlias
    The account type for mail aliases.
  - netgroup
    The account type for NIS netgroups.
  - pykotaBillingCodeType
    The account type for PyKota billing codes.
  - pykotaPrinterType
    The account type for PyKota printers.
  - smbDomain
    The account type for Samba domains.
  - user
    The account type for user accounts (e.g. Unix, Samba and Kolab).